import { IConfig } from '@zeedhi/core';
import prodEnvironment from './prodEnvironment.json';
import devEnvironment from './devEnvironment.json';

const env = process.env.NODE_ENV === 'production' ? prodEnvironment : devEnvironment;

const config: IConfig = {
	endPoint: env.endPoint,
	metadataEndPoint: env.metadataEndPoint,
	dateFormat: 'YYYY-MM-DD',
	displayFormat: 'DD/MM/YYYY',
	datasourceArrayFormat: 'indices',
	env: {
		endPoint: env.endPoint,
	},
};

export default config;
